import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;

public class ParseXmlWithCatalog {
	
	public static void main(String[] args) {
		int validating = JOptionPane.showOptionDialog(null, "Do you want validation?", "Please choose \"Yes\" for validation",
				JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, JOptionPane.YES_OPTION);
		parseDoc(getFile(args), validating == JOptionPane.YES_OPTION);
	}
	
	private static boolean parseDoc(File inFile, boolean validate) {
		if (inFile == null) {
			JOptionPane.showMessageDialog(null, "Failure opening input XML.");
		}
		try {
			/*
			System.setProperty(DOMImplementationRegistry.PROPERTY, "org.apache.xerces.dom.DOMImplementationSourceImpl");
			DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
			DOMImplementationLS impl = (DOMImplementationLS) registry.getDOMImplementation("LS");
			LSParser builder = impl.createLSParser(DOMImplementationLS.MODE_SYNCHRONOUS, null);
	        LSParserFilter filter = new InputFilter();
	        builder.setFilter(filter);
	        */
			DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
			if (!validate) {
				builderFactory.setValidating(false);
				builderFactory.setAttribute("http://apache.org/xml/features/nonvalidating/load-external-dtd", false);
			}
			DocumentBuilder builder = builderFactory.newDocumentBuilder();
			
			Document testDoc = builder.parse(inFile.getPath());
			System.out.println(testDoc.getFirstChild().getNodeName());
		} catch (Exception exc) {
			JOptionPane.showMessageDialog(null, "Failure parsing input XML: " + exc.getMessage());
			return false;
		}
		return true;
	}

	public static File getFile(String[] args) {
		if (args.length > 1) {
			JOptionPane.showMessageDialog(null, "Too many arguments.");
			return null;
		}
		if (args.length == 1) {
			return new File(args[0]);
		}
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setMultiSelectionEnabled(false);
		fileChooser.setDialogTitle("Select 1 XML file");
		FileNameExtensionFilter filter = new FileNameExtensionFilter("XML Files", "xml", "ditamap", "dita", "style");
		fileChooser.setFileFilter(filter);
		int response = fileChooser.showOpenDialog(null);
		if (response != JFileChooser.APPROVE_OPTION) {
			// aborted
			return null;
		}
		return fileChooser.getSelectedFile();

	}

}
